#! /usr/bin/perl -w

# Copyright (c) 2007-2008 Yitzhak Grossman - celejar@gmail.com
# May be used under the terms of the GPL or the Perl Artistic License
# sylxml2csv comes with ABSOLUTELY NO WARRANTY
# Usage: sylxml2csv.pl [-p 'field1 field2 ...'] [-a 'field1 field2 ...'] [-c
# constant-field] < /path/to/addrbook.xml > /path/to/addrbook.csv

use Getopt::Std;
use IO::Wrap;

use XML::Parser;
use Text::CSV_XS;

use strict;

my %known_elements = ('person', \&person, 'address', \&address);
my (%person_attrs, %address_attrs);

my %opts = ('p' => 'first-name last-name cn nick-name', 'a' => 'email remarks');
getopts('p:a:c:', \%opts);
my @person_import_fields = split /\s+/, $opts{'p'};
my @address_import_fields = split /s+/, $opts{'a'};
my $custom = $opts{'c'};
 
my $parser = new XML::Parser;
$parser->setHandlers('Start' => \&start_handler);

my $csv = new Text::CSV_XS({'binary' => 1});
my $stdout = wraphandle(\*STDOUT);

$parser->parse(*STDIN);

# The End!

sub start_handler {

	my $parser = shift;
	my $element = shift;
	&{$known_elements{$element}}(@_) if $known_elements{$element};
}

sub person {
	%person_attrs = @_;
	}

sub address {
	%address_attrs = @_;
	my @elements = (@person_attrs{@person_import_fields}, @address_attrs{@address_import_fields});
	push @elements, $custom if defined($custom);
	$csv->print($stdout, \@elements);
	print "\n";
}
